﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinTree;

namespace _90070
{
    public partial class Form1 : Form
    {
        class CombineCheckState
        {
            CheckState state = CheckState.Indeterminate;

            public object State
            {
                get
                {
                    //if (state == CheckState.Indeterminate)
                    //    return DBNull.Value;
                    return state; //== CheckState.Checked ? true : false;
                }
            }

            public CombineCheckState() { }
            public CombineCheckState(object state)
            {
                if (state.GetType() == typeof(bool))
                    this.state = ((bool)state) ? CheckState.Checked : CheckState.Unchecked;

                if (state.GetType() == typeof(CheckState))
                    this.state = (CheckState)state;
            }

            public CheckState Combine(object NextState)
            {
                CheckState currState = CheckState.Indeterminate;
                if (NextState.GetType() == typeof(bool))
                    currState = ((bool)NextState) ? CheckState.Checked : CheckState.Unchecked;

                if (NextState.GetType() == typeof(CheckState))
                    currState = (CheckState)NextState;

                if (state == currState)
                    state = currState;
                else
                    state = CheckState.Indeterminate;

                return state;
            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            ultraTree1.DataSource = Generate();
            ultraTree1.DataMember = "Table1";
           
            ultraTree1.AfterCheck += new AfterNodeChangedEventHandler(ultraTree1_AfterCheck);
        }

        void ultraTree1_AfterCheck(object sender, NodeEventArgs e)
        {

            ultraTree1.AfterCheck -= new  AfterNodeChangedEventHandler(ultraTree1_AfterCheck);
            Down(e.TreeNode, e.TreeNode.CheckedState);
            UP(e.TreeNode);
            ultraTree1.AfterCheck += new AfterNodeChangedEventHandler(ultraTree1_AfterCheck);
            
        }

        private void Down(UltraTreeNode row, object value)
        {
            if (row.Nodes == null && row.Nodes.Count == 0)
                return;
            foreach (UltraTreeNode node in row.Nodes)
            {
                node.CheckedState = (CheckState)value;
                Down(node, value);
                
            }
        }

        private void UP(UltraTreeNode row)
        {
            if (row == null)
                return;
            CombineCheckState newState = new CombineCheckState(row.CheckedState);
            UltraTreeNode parRow = row.Parent;
            if (parRow == null)
                return;
            foreach (UltraTreeNode node in parRow.Nodes)
            {
                newState.Combine(node.CheckedState);
            }

            parRow.CheckedState = (CheckState)newState.State;
            UP(parRow);
        }

        private DataSet Generate()
        {
            DataTable[] tables = new DataTable[4];

            for (int i = 0; i < 4; i++)
            {
                tables[i] = new DataTable();
                tables[i].Columns.Add("ID", typeof(int)).AutoIncrement = true;
                tables[i].Columns.Add("FID", typeof(int));
                tables[i].Columns.Add("Null", typeof(string));
                tables[i].Columns.Add("Bool", typeof(bool)).DefaultValue = false;
                //for (int col = 0; col < 3; col++)
                //    tables[i].Columns.Add("Col" + col.ToString(), typeof(string)).DefaultValue = "Text table" + i.ToString();

            }

            for (int i1 = 0; i1 < 5; i1++)
            {
                tables[0].Rows.Add(null, i1);
                int key0 = (int)tables[0].Rows[i1].ItemArray[0];

                for (int i2 = 0; i2 < 5; i2++)
                {
                    tables[1].Rows.Add(null, key0);
                    int key1 = (int)tables[1].Rows[tables[1].Rows.Count - 1].ItemArray[0];
                    for (int i3 = 0; i3 < 5; i3++)
                    {
                        tables[2].Rows.Add(null, key1);
                        int key2 = (int)tables[2].Rows[tables[2].Rows.Count - 1].ItemArray[0];
                        for (int i4 = 0; i4 < 5; i4++)
                        {
                            tables[3].Rows.Add(null, key2);
                        }
                    }
                }
            }

            DataSet ret = new DataSet();
            ret.Tables.AddRange(tables);


            for (int i = 3; i > 0; i--)
                ret.Relations.Add(ret.Tables[i - 1].Columns["ID"], ret.Tables[i].Columns["FID"]);
            //ret.Relations.Add(ret.Tables[3].Columns["ID"], ret.Tables[0].Columns["FID"]);
            return ret;
        }

        private void ultraButton1_Click(object sender, EventArgs e)
        {
            ultraTree1.Nodes[0].Nodes[0].Nodes[0].CheckedState = CheckState.Checked;
        }

        private void ultraButton2_Click(object sender, EventArgs e)
        {
            ultraTree1.ExpandAll();
        }

    }
}
